package geniusweb.javavenv;

import java.io.IOException;

import org.junit.Test;

import tudelft.utilities.logging.ReportToLogger;
import tudelft.utilities.logging.Reporter;

/**
 * Contains a Python Venv for a specific python tar.gz file.
 *
 */
public class PythonVenvTest {
	private final Reporter logger = new ReportToLogger("test");

	// "." and "-" not allowed in the name, only _
	@Test(expected = IllegalArgumentException.class)
	public void badNameTest()
			throws IOException, InterruptedException, PythonError {
		PythonVenv env = new PythonVenv("stupidparty-1.0.0", logger);
		env.remove();
	}

	@Test
	public void test() throws IOException, InterruptedException, PythonError {
		PythonVenv env = new PythonVenv("python3party100", logger);
		env.remove();
	}

	/**
	 * One test for both pip list and pip install, because user may have to give
	 * permission for each venv separately
	 */
	@Test
	public void testPipInstallNumpy()
			throws IOException, InterruptedException, PythonError {
		PythonVenv env = new PythonVenv("python3party100", logger);
		env.call("-m pip install --upgrade pip", 20000);
		String res = env.call("-m pip list", 10000);
		System.out.println("pip list gave " + res);
		res = env.call("-m pip install numpy", 30000);
		System.out.println("pip install numpy gave " + res);
		env.remove();
	}

}